#include "C:\Program Files\National Instruments\NI-DAQ\DAQmx ANSI C Dev\include\NIDAQmx.h"

#define DAQmxErrChk(functionCall) if( DAQmxFailed(error=(functionCall)) ) goto Error; else

int32 PisiAO(float64 vrednost)
{
TaskHandle  AOHandle=0;
	int32   ret;
	float64 aOdata;
	char izlaz[10];
	int32 sampsPerChanWritten, numBytesPerSamp;

    // aOdata=(u0[0]);
	DAQmxCreateTask("",&AOHandle);
	DAQmxCreateAOVoltageChan(AOHandle,"Dev1/ao0","",0.0,5.0,DAQmx_Val_Volts,"");

	/*********************************************/
	// DAQmx Start Code
	/*********************************************/
	DAQmxStartTask(AOHandle);

	/*********************************************/
	// DAQmx Write Code
	/*********************************************/
	DAQmxWriteAnalogF64(AOHandle,1,-1,10.0,DAQmx_Val_GroupByChannel,&vrednost,NULL,NULL);
	/*********************************************/
		// DAQmx Stop Code
		/*********************************************/
		DAQmxStopTask(AOHandle);
		DAQmxClearTask(AOHandle);
    return 0;
    }

int Pisi(uInt32 data)
{
		int         error=0;
	TaskHandle	taskHandle=0;
	uInt32      data1=0xffffffff;
	char        errBuff[2048]={'\0'};
	int32		written;

	/*********************************************/
	// DAQmx Configure Code
	/*********************************************/
	DAQmxErrChk (DAQmxCreateTask("",&taskHandle));
	DAQmxErrChk (DAQmxCreateDOChan(taskHandle,"Dev1/port1","",DAQmx_Val_ChanForAllLines));

	/*********************************************/
	// DAQmx Start Code
	/*********************************************/
	DAQmxErrChk (DAQmxStartTask(taskHandle));

	/*********************************************/
	// DAQmx Write Code
	/*********************************************/
	DAQmxErrChk (DAQmxWriteDigitalU32(taskHandle,1,1,10.0,DAQmx_Val_GroupByChannel,&data,&written,NULL));

Error:
	if( DAQmxFailed(error) )
		DAQmxGetExtendedErrorInfo(errBuff,2048);
	if( taskHandle!=0 ) {
		/*********************************************/
		// DAQmx Stop Code
		/*********************************************/
		DAQmxStopTask(taskHandle);
		DAQmxClearTask(taskHandle);
	}
	if( DAQmxFailed(error) )
		printf("DAQmx Error: %s\n",errBuff);
//	printf("End of program, press Enter key to quit\n");
	//getchar();
	return 0;
}

int Citaj(void)
	{
	int32		error=0;
	TaskHandle	hdlcitaj=0;
	uInt32		data;
	char		errBuff[2048]={'\0'};
	int32		read;

	/*********************************************/
	// DAQmx Configure Code
	/*********************************************/
	DAQmxErrChk (DAQmxCreateTask("",&hdlcitaj));
	DAQmxErrChk (DAQmxCreateDIChan(hdlcitaj,"Dev1/port0","",DAQmx_Val_ChanForAllLines));

	/*********************************************/
	// DAQmx Start Code
	/*********************************************/
	DAQmxErrChk (DAQmxStartTask(hdlcitaj));

	/*********************************************/
	// DAQmx Read Code
	/*********************************************/
	DAQmxErrChk (DAQmxReadDigitalU32(hdlcitaj,1,10.0,DAQmx_Val_GroupByChannel,&data,1,&read,NULL));

//	printf("Data acquired: 0x%X\n",data);
	
Error:
	if( DAQmxFailed(error) )
		DAQmxGetExtendedErrorInfo(errBuff,2048);
	if( hdlcitaj!=0 ) {
		/*********************************************/
		// DAQmx Stop Code
		/*********************************************/
		DAQmxStopTask(hdlcitaj);
		DAQmxClearTask(hdlcitaj);
	}
	if( DAQmxFailed(error) )
		printf("DAQmx Error: %s\n",errBuff);
	//printf("End of program, press Enter key to quit\n");
//	getchar();
	return data;

}
int CitajBrzinu(uInt32 *brzina)
{
	int         error=0;
	uInt32      LoByte;
	char        errBuff[2048]={'\0'};

	// Merimo brzinu omega f/omega -1 hi - 0 latch -0
	Pisi(0x04);
	LoByte=Citaj();
	//printf("LoByte: 0x%X\n",LoByte);	

	// Trazimo HiBytea fi/omega -1 hi - 0 latch -1
	Pisi(0x05);
	//printf("HiByte: 0x%X\n",Citaj());

	// unlatch omega fi/omega -0 hi - 0 latch -0
	Pisi(0x00);
    brzina=LoByte;
	return LoByte;
}


